### Metadatenanalyse

import pandas as pd
import numpy as np
import seaborn as sns


df = pd.read_pickle(".\dataframe_all")
uk_dataframe = df[df["Country"]=="UK"]
us_dataframe = df[df["Country"]=="US"]
au_dataframe = df[df["Country"]=="AU"]

sns.set()


# Berechnet die Anzahl der Artikel im übergebenen Dataframe

def amount_of_articles(df_article):
    amount = df_article.count()
    return amount



# Berechnet die Gesamtlänge aller Artikel im übergebenen Dataframe
# zwei Versionen

# falls keine Spalte Length after vorhanden ist:
# sum(len(article.split()) for article in df_article)


# nutzt die vorher berechnete Spalte "Length after", welche die Länge des bereinigten Textes enthält:

def total_len(df_length_after):
    total = sum(df_lenght_after)
    return total


# Grafik Anzahl von Artikeln pro Land

nach_land = df.groupby("Country")
nach_land.count()

country = ["AU","UK","US"]
values_l = nach_land.count()["Article"]
plt.bar(country,values_l,alpha=0.5, color="green")
plt.title("Number of articles in different counries",fontsize=20)
plt.xlabel("Country", fontsize=15)
plt.ylabel("Articles", fontsize=15)

# get current size
fig_size = plt.rcParams["figure.figsize"]
# set figure width to 12 and height to 9 
fig_size[0] = 15
fig_size[1] = 10
plt.rcParams["figure.figsize"] = fig_size

# Aufteilung nach Länder 
us_df=df[df["Country"]=="US"]
uk_df=df[df["Country"]=="UK"]
au_df=df[df["Country"]=="AU"]

################## Länge der Artikel - Vergleich ########################


######### US ANALYSE ########

nach_paper1 = us_df.groupby("Paper")
nach_paper1.count()

# Diagramm: Anzahl von Artikeln in verschiedenen Zeitungen für US

d = nach_paper1.count()["Article"].plot(kind="bar", figsize=(13, 10), legend=True, fontsize=12, color="green", alpha=0.5)
d.set_xlabel("Papers", fontsize=15)
d.set_ylabel("Articles", fontsize=15)
d.set_title("Number of articles in different papers - US",fontsize=20)
d.legend(fontsize=15)

############# US - Länge before und Länge after-Vergleich

plt.hist(us_df["Length before"], alpha=0.5, bins=35, color="yellow",label="Length before")
plt.hist(us_df["Length after"], alpha=0.5, bins=35, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 6000, 0, 40000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - US")

# US Length befor vs. after Vergleich - nach Paper #

help_df=us_df[us_df["Paper"]=="ABC News"]

plt.hist(help_df["Length before"], alpha=0.5, bins=60, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5, bins=60, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 4000, 0, 6000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - ABC News")

help_df=us_df[us_df["Paper"]=="BBC US"]

plt.hist(help_df["Length before"], alpha=0.5,bins=15, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5,bins=15, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 4000, 0, 1000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - BBC US")

help_df=us_df[us_df["Paper"]=="CBS"]

plt.hist(help_df["Length before"], alpha=0.5,bins=40, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5,bins=40, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 7100, 0, 4000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - CBS")

help_df=us_df[us_df["Paper"]=="CNN"]

plt.hist(help_df["Length before"], alpha=0.5,bins=15, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5,bins=15, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 1750, 0, 2000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - CNN")

help_df=us_df[us_df["Paper"]=="Fox News"]

plt.hist(help_df["Length before"], alpha=0.5,bins=35, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5,bins=35, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 5000, 0, 8000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - Fox News")

help_df=us_df[us_df["Paper"]=="NPR"]

plt.hist(help_df["Length before"], alpha=0.5,bins=35, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5,bins=35, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 5000, 0, 1500])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - NPR")

help_df=us_df[us_df["Paper"]=="New York Times"]

plt.hist(help_df["Length before"], alpha=0.5,bins=15, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5,bins=15, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 2000, 0, 4000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - New York Times")

help_df=us_df[us_df["Paper"]=="Reuters"]

plt.hist(help_df["Length before"], alpha=0.5,bins=25, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5,bins=25, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 2000, 0, 3000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - Reuters")

help_df=us_df[us_df["Paper"]=="Washington Post"]

plt.hist(help_df["Length before"], alpha=0.5,bins=35, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5,bins=35, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 10000, 0, 7000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - Washington Post")


######### AU ANALYSE ########

nach_paper2 = au_df.groupby("Paper")
nach_paper2.count()

# Diagramm: Anzahl von Artikeln in verschiedenen Zeitungen für AU

d = nach_paper2.count()["Article"].plot(kind="bar", figsize=(15, 10), legend=True, fontsize=12, color="green", alpha=0.5)
d.set_xlabel("Papers", fontsize=15)
d.set_ylabel("Articles", fontsize=15)
d.set_title("Number of articles in different papers - AU",fontsize=20)
d.legend(fontsize=15)

# AU Length befor vs. after Vergleich

plt.hist(au_df["Length before"], alpha=0.5, bins=35, color="yellow",label="Length before")
plt.hist(au_df["Length after"], alpha=0.5, bins=35, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 4000, 0, 20000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - AU")

# AU Length befor vs. after Vergleich - nach Paper #

help_df=au_df[au_df["Paper"]=="ABC Australia"]

plt.hist(help_df["Length before"], alpha=0.5, bins=20, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5, bins=20, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 2000, 0, 2000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - ABC Australia")

help_df=au_df[au_df["Paper"]=="Canberra Times"]

plt.hist(help_df["Length before"], alpha=0.5, bins=10, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5, bins=10, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 2000, 0, 30])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - Canberra Times ")

help_df=au_df[au_df["Paper"]=="News Australia"]

plt.hist(help_df["Length before"], alpha=0.5, bins=25, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5, bins=25, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 3000, 0, 2000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - News Australia")

help_df=au_df[au_df["Paper"]=="The Advertiser"]

plt.hist(help_df["Length before"], alpha=0.5, bins=30, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5, bins=30, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 5000, 0, 2000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - The Advertiser")

help_df=au_df[au_df["Paper"]=="The Daily Telegraph AU"]

plt.hist(help_df["Length before"], alpha=0.5, bins=20, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5, bins=20, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 3000, 0, 2000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - The Daily Telegraph AU")

help_df=au_df[au_df["Paper"]=="The Mercury"]

plt.hist(help_df["Length before"], alpha=0.5, bins=40, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5, bins=40, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 3000, 0, 9000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - The Mercury")

help_df=au_df[au_df["Paper"]=="The west australian"]

plt.hist(help_df["Length before"], alpha=0.5, bins=30, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5, bins=30, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 2000, 0, 2000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - The west australian")


######### UK ANALYSE ########

nach_paper3 = uk_df.groupby("Paper")
nach_paper3.count()

# Diagramm: Anzahl von Artikeln in verschiedenen Zeitungen für UK

d = nach_paper3.count()["Article"].plot(kind="bar", figsize=(15, 10), legend=True, fontsize=12, color="green", alpha=0.5)
d.set_xlabel("Papers", fontsize=15)
d.set_ylabel("Articles", fontsize=15)
d.set_title("Number of articles in different papers - UK",fontsize=20)
d.legend(fontsize=15)

# UK Length befor vs. after Vergleich

plt.hist(uk_df["Length before"], alpha=0.5, bins=35, color="yellow",label="Length before")
plt.hist(uk_df["Length after"], alpha=0.5, bins=35, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 7000, 0, 20000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - UK")

# UK Length befor vs. after Vergleich - nach Paper #

help_df=uk_df[uk_df["Paper"]=="Daily Express"]

plt.hist(help_df["Length before"], alpha=0.5, bins=30, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5, bins=30, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 1750, 0, 2000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - Daily Express")

help_df=uk_df[uk_df["Paper"]=="Daily Mail"]

plt.hist(help_df["Length before"], alpha=0.5, bins=40, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5, bins=40, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 7000, 0, 15000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - Daily Mail")

help_df=uk_df[uk_df["Paper"]=="The Guardian"]

plt.hist(help_df["Length before"], alpha=0.5, bins=40, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5, bins=40, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 5000, 0, 3000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - The Guardian")

help_df=uk_df[uk_df["Paper"]=="The Independent"]

plt.hist(help_df["Length before"], alpha=0.5, bins=30, color="yellow",label="Length before")
plt.hist(help_df["Length after"], alpha=0.5, bins=30, color="green",label="Length after")
plt.legend(loc="upper right")
plt.axis([0, 6000, 0, 2000])
plt.ylabel("Number of articles")
plt.xlabel("Length of articles")
plt.suptitle("Length differences after cleaning - The Independent")


# Grafik Gesamt-Textlänge pro Land

us_t = int(total_len(us_dataframe['Lenght after']))
uk_t = int(total_len(uk_dataframe['Lenght after']))
au_t = int(total_len(au_dataframe['Lenght after']))
values_t = [us_t, uk_t, au_t]
country = ['US', 'UK', 'AU']
                                                                        
plt.bar(country, values_t, alpha=0.5, color="green") 
plt.title("Total text length in different countries",fontsize=20) 
plt.xlabel("Country", fontsize=15)
plt.ylabel("Total text length", fontsize=15)



# Berechnet die Textlänge pro Artikel

def len_article(df_article):
    art = []
    for a in article:
        length = (len(a.split()))
        art.append(length)
    return(art)


# Berechnet die durchschnittliche Textlänge aller Artikel für ein Land
# zwei Versionen

# falls keine Spalte Length after vorhanden ist:

def avgartlen(df_article):
    a_al = []
    for a in article:
        length = (len(a.split()))
        a_al.append(length)
    avg_len = sum(a_al) / amount_of_articles(df_article)
    return avg_len


# kürzer, mit Hilfe der Spalte Length after, diese haben wir benutzt:

def avg_art_len(df_length_after):
    a_al = sum(df_length_after) / amount_of_articles(df_article)
    return a_al


# Grafik Textlänge mit Durchschnitt 

plt.hist(len_artikel(df["Article"]), bins = 100, color="green", alpha=0.5)
plt.axvline(x = avg_art_len(df['Length after']), color='r') 
plt.axis([0, 3000, 0, 6500])
plt.xlabel("Article length",fontsize=15)
plt.ylabel("Amount",fontsize=15)
plt.title("Article length per country with average - AU",fontsize=20)


# Grafik durchschnittliche Textlänge pro Land

us_l = int(avg_art_len(us_dataframe['Length after']))
uk_l = int(avg_art_len(uk_dataframe['Length after']))
au_l = int(avg_art_len(au_dataframe['Length after']))
values_l = [us_l, uk_l, au_l]
country = ['US', 'UK', 'AU']
                                                                        
plt.bar(country, values_l, alpha=0.5, color='green')  
plt.xlabel("Country")
plt.ylabel("Average length")
plt.title("Average article length per country")


# Berechtnet die Anzahl unique words pro Artikel

def number_uniq(df_article):    
    uniq = []
    for a in article:
        amount = (len(set(a.split())))
        uniq.append(amount)
    return(uniq)
        

# Zur weiteren Nutzung werden die Ergebnisse von number_uniq in eine neue Spalte des Dataframes gepackt

df['# Unique Words'] = number_uniq(df_article)


# Berechnet die durchschnittliche Anzahl der unique words aller Artikel
# zwei Versionen

# falls keine Spalte # Unique Words vorhanden ist:

def avguniq(df_article):
    avg = []
    for a in article:
        uw = (len(set(a.split())))
        avg.append(uw)
    avg_uw = sum(avg) / amount_of_articles(df_article)
    return avg_uw


# kürzer, mit Hilfe der Spalte # Unique Words, diese haben wir benutzt:

def avg_uniq(df_unique_words):
    uw = sum(df_unique_words) / amount_of_articles(df_article)
    return uw

# Grafik Anzahl Unique Words mit Durchschnitt

plt.hist(number_uniq(df['Article']), bins = 50, color="green", alpha=0.5)
plt.axvline(x = avg_uniq(df['# Unique Words']), color='r')
plt.axis([0, 3000, 0, 25000])
plt.xlabel("Number of unique words",fontsize=15)
plt.ylabel("Amount",fontsize=15)
plt.title("Number of unique words per country with average - US",fontsize=20)



# Grafik durchschnittliche Anzahl Unique Words pro Land

us_u = int(avg_uniq(us_dataframe['# Unique Words']))
uk_u = int(avg_uniq(uk_dataframe['# Unique Words']))
au_u = int(avg_uniq(au_dataframe['# Unique Words']))
values_u = [us_u, uk_u, au_u]
country = ['US', 'UK', 'AU']
                                                                        
plt.bar(country, values_u, alpha=0.5, color='green')  
plt.xlabel("Country")
plt.ylabel("Average # Unique Words")


# Berechnet die durchschnittliche Wortlänge pro Artikel
# Es wird die Summe aller Buchstaben durch die Anzahl der Wörter geteilt

def avg_wordlen(df_article):
    avg_word = []
    for a in article:
        words = a.split()
        if len(words) > 0:
            average = sum(len(word) for word in words) / len(words)
        avg_word.append(average)
    return(avg_word)
       
    
# Zur weiteren Nutzung werden die Ergebnisse von avg_wordlen in eine neue Spalte des Dataframes gepackt

df['Avg-Wordlength'] = avg_wordlen(df_article)


# Berechnet die durchschnittliche Wortlänge pro Land
# hier wird der Methode das gesamte Dataframe übergeben, ohne die Spalte zu spezifizieren

def avg_wordlen_country(df):    
    avg = sum(df['Avg-Wordlength']) / amount_of_articles(df['Article'])
    return(avg)



# Grafik durchschnittliche Wortlänge pro Artikel mit Durchschnitt

plt.hist(avg_wordlen(df['Article']), bins = 100, color="green", alpha=0.5)
plt.axvline(x = avg_wordlen_country(df['Avg-Wordlength']), color='r')
plt.axis([0, 14, 0, 30000])
plt.xlabel("Average word length",fontsize=15)
plt.ylabel("Amount",fontsize=15)
plt.title("Average word length per article with country average - US",fontsize=20)



# Grafik durchschnittliche Wortlänge pro Land

us_w = int(avg_wordlen_country(us_dataframe['Avg-Wordlength']))
uk_w = int(avg_wordlen_country(uk_dataframe['Avg-Wordlength']))
au_w = int(avg_wordlen_country(au_dataframe['Avg-Wordlength']))
values_w = [us_w, uk_w, au_w]
country = ['US', 'UK', 'AU']
                                                                        
plt.bar(country, values_w, alpha=0.5, color='green')  
plt.xlabel("Country", fontsize=15)
plt.ylabel("Average word length", fontsize=15)




